'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Avator = function (_Component) {
  _inherits(Avator, _Component);

  function Avator() {
    _classCallCheck(this, Avator);

    return _possibleConstructorReturn(this, (Avator.__proto__ || Object.getPrototypeOf(Avator)).apply(this, arguments));
  }

  _createClass(Avator, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          backgroundColor = _props.backgroundColor,
          icon = _props.icon,
          src = _props.src,
          style = _props.style,
          size = _props.size,
          color = _props.color,
          className = _props.className,
          other = _objectWithoutProperties(_props, ['backgroundColor', 'icon', 'src', 'style', 'size', 'color', 'className']);

      var mergedClassNames = (0, _classnames2.default)(_defineProperty({
        'zui-avator-wrap': true
      }, className, !!className));
      var mergedStyle = { fontSize: size / 2 + 'px' };
      var mergedIconStyle = { fontSize: size * 0.6 + 'px' };
      if (backgroundColor) {
        mergedStyle.backgroundColor = backgroundColor;
      }
      if (size) {
        mergedStyle.width = mergedStyle.height = size + 'px';
        mergedIconStyle.width = mergedIconStyle.height = size * 0.6 + 'px';
        mergedIconStyle.margin = size * 0.2 + 'px';
      }
      if (color) {
        mergedStyle.color = color;
      }
      mergedStyle = _extends({}, style, mergedStyle);

      if (src) {
        return _react2.default.createElement('img', _extends({
          style: mergedStyle
        }, other, {
          src: src,
          className: mergedClassNames
        }));
      } else {
        return _react2.default.createElement(
          'div',
          _extends({}, other, {
            style: mergedStyle,
            className: mergedClassNames
          }),
          icon && (0, _react.cloneElement)(icon, {
            color: color || icon.props.color || '#fff',
            style: _extends(mergedIconStyle, icon.props.style)
          }),
          this.props.children
        );
      }
    }
  }]);

  return Avator;
}(_react.Component);

Avator.propTypes = {
  backgroundColor: _propTypes2.default.string,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  color: _propTypes2.default.string,
  icon: _propTypes2.default.element,
  size: _propTypes2.default.number,
  src: _propTypes2.default.string,
  style: _propTypes2.default.object
};
Avator.defaultProps = {
  size: 40
};
exports.default = Avator;