'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classNames2 = require('classNames');

var _classNames3 = _interopRequireDefault(_classNames2);

var _checkBoxOutlineBlank = require('../svg-embedded/check-box-outline-blank');

var _checkBoxOutlineBlank2 = _interopRequireDefault(_checkBoxOutlineBlank);

var _checkBox = require('../svg-embedded/check-box');

var _checkBox2 = _interopRequireDefault(_checkBox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Checkbox = function (_Component) {
  _inherits(Checkbox, _Component);

  function Checkbox() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Checkbox);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      checked: false
    }, _this.handleTouchTap = function (event) {
      if (_this.props.disabled) return;
      var checked = _this.state.checked;

      if (_this.props.checked === undefined) {
        _this.setState({
          checked: !checked
        });
      }
      if (_this.props.onCheck) {
        _this.props.onCheck(event, !checked);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Checkbox, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          checked = _props.checked,
          defaultChecked = _props.defaultChecked;


      if (checked || defaultChecked) {
        this.setState({ checked: true });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.disabled) return;
      if (nextProps.checked !== undefined && nextProps.checked !== this.checked) {
        this.setState({
          checked: nextProps.checked
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _classNames;

      var _props2 = this.props,
          defaultChecked = _props2.defaultChecked,
          label = _props2.label,
          labelStyle = _props2.labelStyle,
          labelPosition = _props2.labelPosition,
          className = _props2.className,
          disabled = _props2.disabled,
          style = _props2.style,
          checked = _props2.checked;


      var mergedClass = (0, _classNames3.default)((_classNames = {
        'zui-checkbox': true
      }, _defineProperty(_classNames, className, !!className), _defineProperty(_classNames, 'disabled', disabled), _defineProperty(_classNames, 'is-checked', this.state.switched), _defineProperty(_classNames, 'position-left', labelPosition === 'left'), _classNames));

      var mergedCheckClass = (0, _classNames3.default)({
        'zui-checkbox-uncheck-icon': true,
        'is-checked': this.state.checked
      });

      var mergedUnCheckClass = (0, _classNames3.default)({
        'zui-checkbox-check-icon': true,
        'is-checked': this.state.checked
      });

      var content = labelPosition === 'left' ? [_react2.default.createElement(
        'label',
        { key: 'label', className: 'zui-checkbox-label', style: labelStyle },
        label
      ), _react2.default.createElement(
        'div',
        { key: 'checkbox', className: 'zui-checkbox-icon-wrap' },
        _react2.default.createElement(_checkBoxOutlineBlank2.default, { className: mergedCheckClass }),
        _react2.default.createElement(_checkBox2.default, { className: mergedUnCheckClass })
      )] : [_react2.default.createElement(
        'div',
        { key: 'checkbox', className: 'zui-checkbox-icon-wrap' },
        _react2.default.createElement(_checkBoxOutlineBlank2.default, { className: mergedCheckClass }),
        _react2.default.createElement(_checkBox2.default, { className: mergedUnCheckClass })
      ), _react2.default.createElement(
        'label',
        { key: 'label', className: 'zui-checkbox-label', style: labelStyle },
        label
      )];
      var inputProps = {
        type: 'checkbox',
        className: 'zui-toggle-checkbox',
        onTouchTap: this.handleTouchTap
      };
      if (this.props.hasOwnProperty('defaultChecked')) {
        inputProps.defaultChecked = defaultChecked;
      } else if (this.props.hasOwnProperty('checked')) {
        inputProps.checked = checked;
      }
      return _react2.default.createElement(
        'div',
        { className: mergedClass, style: style },
        _react2.default.createElement('input', inputProps),
        _react2.default.createElement(
          'div',
          { className: 'zui-checkbox-track-wrap' },
          content
        )
      );
    }
  }]);

  return Checkbox;
}(_react.Component);

Checkbox.propTypes = {
  checked: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  defaultChecked: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  label: _propTypes2.default.string,
  labelPosition: _propTypes2.default.oneOf(['left', 'right']),
  labelStyle: _propTypes2.default.object,
  onCheck: _propTypes2.default.func,
  style: _propTypes2.default.object
};
Checkbox.defaultProps = {
  defaultChecked: false,
  disabled: false,
  labelPosition: 'right'
};
exports.default = Checkbox;