'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactEventListener = require('react-event-listener');

var _reactEventListener2 = _interopRequireDefault(_reactEventListener);

var _Overlay = require('../internal/Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _Shade = require('../Shade');

var _Shade2 = _interopRequireDefault(_Shade);

var _keycode = require('keycode');

var _keycode2 = _interopRequireDefault(_keycode);

var _CSSTransitionGroup = require('react-transition-group/CSSTransitionGroup');

var _CSSTransitionGroup2 = _interopRequireDefault(_CSSTransitionGroup);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _clear = require('../svg-embedded/clear');

var _clear2 = _interopRequireDefault(_clear);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dialog = function (_Component) {
  _inherits(Dialog, _Component);

  function Dialog() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Dialog);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call.apply(_ref, [this].concat(args))), _this), _this.handleTouchTapOverlay = function () {
      _this.requestClose(false);
    }, _this.handleClickCancel = function () {
      _this.requestClose(true);
    }, _this.handleClickConfirm = function () {
      if (_this.props.onRequestConfirm) {
        _this.props.onRequestConfirm();
      }
    }, _this.handleKeyUp = function (event) {
      if ((0, _keycode2.default)(event) === 'esc') {
        _this.requestClose(false);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Dialog, [{
    key: 'requestClose',
    value: function requestClose(buttonClicked) {
      if (!buttonClicked && this.props.modal) {
        return;
      }

      if (this.props.onRequestClose) {
        this.props.onRequestClose(!!buttonClicked);
      }
    }
  }, {
    key: 'createFooterElement',
    value: function createFooterElement() {
      var footer = _react2.default.createElement(
        'div',
        { className: 'zui-dialog-footer' },
        _react2.default.Children.count(this.props.actions) > 0 ? _react2.default.Children.toArray(this.props.actions) : [_react2.default.createElement(_Button2.default, {
          type: 'text',
          label: '\u53D6\u6D88',
          key: 'cancel',
          onClick: this.handleClickCancel
        }), _react2.default.createElement(_Button2.default, {
          label: '\u786E\u5B9A',
          key: 'confirm',
          onClick: this.handleClickConfirm
        })]
      );

      return footer;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          title = _props.title,
          open = _props.open,
          size = _props.size,
          showClose = _props.showClose;


      var titleElement = _react2.default.createElement(
        'div',
        { className: 'zui-dialog-header' },
        _react2.default.createElement(
          'span',
          { className: 'zui-dialog-title' },
          title
        ),
        showClose && _react2.default.createElement(_clear2.default, { className: 'zui-dialog-close', onClick: this.handleClickCancel })
      );

      var footerElement = this.createFooterElement();

      var rootClassName = (0, _classnames2.default)({
        'zui-dialog': true,
        'is-open': !!open
      });

      var bodyClassName = (0, _classnames2.default)(_defineProperty({
        'zui-dialog-body': true
      }, 'zui-dialog-' + size, true));

      return _react2.default.createElement(
        'div',
        { className: rootClassName },
        open && _react2.default.createElement(_reactEventListener2.default, {
          target: 'window',
          onKeyUp: this.handleKeyUp
        }),
        _react2.default.createElement(
          _CSSTransitionGroup2.default,
          {
            component: 'div',
            transitionName: 'zui-dialog',
            transitionAppear: true,
            transitionAppearTimeout: 450,
            transitionEnterTimeout: 450,
            transitionLeaveTimeout: 450
          },
          open && _react2.default.createElement(
            _Shade2.default,
            { zDepth: 4, className: bodyClassName, key: 'shade' },
            titleElement,
            _react2.default.createElement(
              'div',
              { className: 'zui-dialog-content' },
              children
            ),
            footerElement
          )
        ),
        _react2.default.createElement(_Overlay2.default, {
          show: open,
          onTouchTap: this.handleTouchTapOverlay
        })
      );
    }
  }]);

  return Dialog;
}(_react.Component);

Dialog.propTypes = {
  actions: _propTypes2.default.node,
  autoDetectWindowHeight: _propTypes2.default.bool,
  autoScrollBodyContent: _propTypes2.default.bool,
  bodyClassName: _propTypes2.default.string,
  bodyStyle: _propTypes2.default.object,
  children: _propTypes2.default.node,
  contentClassName: _propTypes2.default.string,
  contentStyle: _propTypes2.default.object,
  modal: _propTypes2.default.bool,
  onRequestClose: _propTypes2.default.func,
  onRequestConfirm: _propTypes2.default.func,
  open: _propTypes2.default.bool.isRequired,
  repositionOnUpdate: _propTypes2.default.bool,
  showClose: _propTypes2.default.bool,
  size: _propTypes2.default.oneOf(['tiny', 'small', 'large', 'full']),
  style: _propTypes2.default.object,
  title: _propTypes2.default.string
};
Dialog.defaultProps = {
  autoDetectWindowHeight: true,
  autoScrollBodyContent: false,
  modal: false,
  repositionOnUpdate: true,
  size: 'small',
  showClose: true,
  title: '提示'
};
exports.default = Dialog;