'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Popover = require('../Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _PopoverAnimationVertical = require('../Popover/PopoverAnimationVertical');

var _PopoverAnimationVertical2 = _interopRequireDefault(_PopoverAnimationVertical);

var _DropdownMenu = require('./DropdownMenu');

var _DropdownMenu2 = _interopRequireDefault(_DropdownMenu);

var _event = require('../util/event');

var _event2 = _interopRequireDefault(_event);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = function (_Component) {
  _inherits(Dropdown, _Component);

  function Dropdown() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Dropdown);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      open: false
    }, _this.handleMouseEnter = function () {
      _this.onAnchorEl = true;
      if (_this.timeoutTarget) {
        clearTimeout(_this.timeoutTarget);
      }
      _this.setState({
        open: true
      });
    }, _this.handleMouseLeave = function () {
      _this.onAnchorEl = false;
      if (!_this.onTargetEl) {
        _this.timeoutAnchor = setTimeout(function () {
          _this.setState({
            open: false
          });
        }, 300);
      }
    }, _this.handleClick = function (event) {
      if (_this.props.anchorEl.props.onClick) {
        _this.props.anchorEl.props.onClick(event);
      }
      _this.setState({
        open: !_this.state.open
      });
    }, _this.handleRequestClose = function () {
      _this.setState({
        open: false
      });
    }, _this.handleChange = function (event, value) {
      if (_this.props.hideOnClick) {
        _this.setState({
          open: false
        });
      }
      _this.props.onChange(event, value);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Dropdown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var trigger = this.props.trigger;
      // this.el = ReactDOM.findDOMNode(this);

      if (this.el) {
        if (trigger === 'hover') {
          _event2.default.on(this.el, 'mouseenter', this.handleMouseEnter);
          _event2.default.on(this.el, 'mouseleave', this.handleMouseLeave);
        } else {
          _event2.default.on(this.el, 'click', this.handleClick);
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.trigger === 'hover') {
        _event2.default.off(this.el, 'mouseEnter', this.handleMouseEnter);
        _event2.default.off(this.el, 'mouseLeave', this.handleMouseLeave);
      } else {
        _event2.default.off(this.el, 'click', this.handleClick);
      }
      if (this.timeoutAnchor) {
        clearTimeout(this.timeoutAnchor);
      }
      if (this.timeoutTarget) {
        clearTimeout(this.timeoutTarget);
      }
    }
  }, {
    key: 'createWrappedChildren',
    value: function createWrappedChildren(children) {
      var _this2 = this;

      return _react.Children.map(children, function (child) {
        var _child$props = child.props,
            _onMouseEnter = _child$props.onMouseEnter,
            _onMouseLeave = _child$props.onMouseLeave,
            children = _child$props.children,
            other = _objectWithoutProperties(_child$props, ['onMouseEnter', 'onMouseLeave', 'children']);

        if (child.type === _DropdownMenu2.default) {
          return (0, _react.cloneElement)(child, _extends({
            onMouseEnter: function onMouseEnter(event) {
              _this2.onTargetEl = true;
              if (_this2.timeoutAnchor) {
                clearTimeout(_this2.timeoutAnchor);
              }
              if (_onMouseEnter) {
                _onMouseEnter(event);
              }
            },
            onMouseLeave: function onMouseLeave(event) {
              _this2.onTargetEl = false;
              if (!_this2.onAnchorEl && _this2.props.trigger === 'hover') {
                _this2.timeoutTarget = setTimeout(function () {
                  _this2.setState({
                    open: false
                  });
                }, 300);
              }
              if (_onMouseLeave) {
                _onMouseLeave(event);
              }
            },
            onChange: _this2.handleChange
          }, other));
        } else {
          return null;
        }
      });
    }
  }, {
    key: 'createAnchorChildren',
    value: function createAnchorChildren(anchorChildren) {
      var _props = this.props,
          anchorAlign = _props.anchorAlign,
          animation = _props.animation,
          children = _props.children,
          targetAlign = _props.targetAlign,
          useLayerForClickAway = _props.useLayerForClickAway,
          trigger = _props.trigger;


      var popover = _react2.default.createElement(
        _Popover2.default,
        {
          open: this.state.open,
          anchorEl: this.el,
          animation: animation,
          anchorOrigin: { horizontal: targetAlign, vertical: 'bottom' },
          targetOrigin: { horizontal: anchorAlign, vertical: 'top' },
          onRequestClose: this.handleRequestClose,
          useLayerForClickAway: useLayerForClickAway,
          trigger: trigger,
          key: 'popover'
        },
        this.createWrappedChildren(children)
      );
      anchorChildren = _react.Children.toArray(anchorChildren);
      anchorChildren.push(popover);
      return anchorChildren;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return (0, _react.cloneElement)(this.props.anchorEl, {
        ref: function ref(el) {
          return _this3.el = _reactDom2.default.findDOMNode(el);
        }
      }, this.createAnchorChildren(this.props.anchorEl.props.children));
    }
  }]);

  return Dropdown;
}(_react.Component);

Dropdown.propTypes = {
  anchorAlign: _propTypes2.default.oneOf(['left', 'middle', 'right']),
  anchorEl: _propTypes2.default.element.isRequired,
  animation: _propTypes2.default.func,
  children: _propTypes2.default.node,
  hideOnClick: _propTypes2.default.bool,
  onChange: _propTypes2.default.func,
  targetAlign: _propTypes2.default.oneOf(['left', 'middle', 'right']),
  trigger: _propTypes2.default.oneOf(['hover', 'click']),
  useLayerForClickAway: _propTypes2.default.bool
};
Dropdown.defaultProps = {
  anchorAlign: 'middle',
  animation: _PopoverAnimationVertical2.default,
  onChange: function onChange() {},
  trigger: 'hover',
  targetAlign: 'middle',
  useLayerForClickAway: false,
  hideOnClick: true
};
exports.default = Dropdown;