'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _shallowEqual = require('recompose/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _NestedList = require('./NestedList');

var _NestedList2 = _interopRequireDefault(_NestedList);

var _ReinforcedButton = require('../internal/ReinforcedButton');

var _ReinforcedButton2 = _interopRequireDefault(_ReinforcedButton);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _expandLess = require('../svg-embedded/expand-less');

var _expandLess2 = _interopRequireDefault(_expandLess);

var _expandMore = require('../svg-embedded/expand-more');

var _expandMore2 = _interopRequireDefault(_expandMore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var nestedLevelDepth = 18;

var ListItem = function (_Component) {
  _inherits(ListItem, _Component);

  function ListItem() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ListItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ListItem.__proto__ || Object.getPrototypeOf(ListItem)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      hovered: false,
      open: false,
      touch: false
    }, _this.handleMouseEnter = function (event) {
      if (!_this.state.touch) _this.setState({ hovered: true });
      _this.props.onMouseEnter(event);
    }, _this.handleMouseLeave = function (event) {
      _this.setState({ hovered: false });
      _this.props.onMouseLeave(event);
    }, _this.handleNestedListToggle = function (event) {
      event.stopPropagation();
      if (_this.props.onTouchTap) {
        _this.props.onTouchTap();
      }
      if (_this.props.open === null) {
        _this.setState({ open: !_this.state.open }, function () {
          _this.props.onNestedListToggle(_this);
        });
      } else {
        // Exposing `this` in the callback is quite a bad API.
        // I'm doing a one level deep clone to expose a fake state.open.
        _this.props.onNestedListToggle(_extends({}, _this, {
          state: {
            open: !_this.state.open
          }
        }));
      }
    }, _this.handleTouchStart = function (event) {
      _this.setState({ touch: true });
      _this.props.onTouchStart(event);
    }, _this.handleTouchEnd = function (event) {
      _this.setState({ touch: true });
      _this.props.onTouchEnd(event);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ListItem, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.setState({
        open: this.props.open === null ? this.props.initiallyOpen === true : this.props.open
      });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // update the state when the component is controlled.
      if (nextProps.open !== null) this.setState({ open: nextProps.open });
      if (nextProps.disabled && this.state.hovered) this.setState({ hovered: false });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(0, _shallowEqual2.default)(this.props, nextProps) || !(0, _shallowEqual2.default)(this.state, nextState);
    }
  }, {
    key: 'createDisabledElement',
    value: function createDisabledElement(contentChildren, additionalProps) {
      var _props = this.props,
          innerDivStyle = _props.innerDivStyle,
          style = _props.style,
          primaryText = _props.primaryText,
          nestedLevel = _props.nestedLevel;


      var mergedDivStyles = _extends({}, {
        marginLeft: nestedLevel * nestedLevelDepth + 'px'
      }, innerDivStyle, style);

      return _react2.default.createElement(
        'div',
        _extends({}, additionalProps, {
          className: 'zui-listItem disabled',
          style: mergedDivStyles
        }),
        primaryText || contentChildren
      );
    }
  }, {
    key: 'pushElement',
    value: function pushElement(children, element, baseStyles, additionalProps) {
      if (element) {
        var styles = _extends({}, baseStyles, element.props.style);
        children.push(_react2.default.cloneElement(element, _extends({
          key: children.length,
          style: styles
        }, additionalProps)));
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          nestedItems = _props2.nestedItems,
          nestedLevel = _props2.nestedLevel,
          disabled = _props2.disabled,
          className = _props2.className,
          containerElement = _props2.containerElement,
          primaryTogglesNestedList = _props2.primaryTogglesNestedList,
          onTouchTap = _props2.onTouchTap,
          onNestedListToggle = _props2.onNestedListToggle,
          style = _props2.style,
          innerDivStyle = _props2.innerDivStyle,
          initiallyOpen = _props2.initiallyOpen,
          children = _props2.children,
          primaryText = _props2.primaryText,
          other = _objectWithoutProperties(_props2, ['nestedItems', 'nestedLevel', 'disabled', 'className', 'containerElement', 'primaryTogglesNestedList', 'onTouchTap', 'onNestedListToggle', 'style', 'innerDivStyle', 'initiallyOpen', 'children', 'primaryText']);

      var hasNestListItems = nestedItems.length;
      var contentChildren = [primaryText || children];

      if (hasNestListItems) {
        var rightIconButtonElement = this.state.open ? _react2.default.createElement(_expandLess2.default, { className: 'zui-listItem-arraw' }) : _react2.default.createElement(_expandMore2.default, { className: 'zui-listItem-arraw' });

        this.pushElement(contentChildren, rightIconButtonElement, {}, {});
      }

      var nestedList = nestedItems.length ? _react2.default.createElement(
        _NestedList2.default,
        { nestedLevel: nestedLevel, open: this.state.open },
        nestedItems
      ) : undefined;

      var mergedInnerDivStyle = _extends({}, innerDivStyle, {
        marginLeft: nestedLevel * nestedLevelDepth + 'px'
      });
      var mergedClassName = (0, _classnames2.default)(_defineProperty({
        'zui-listItem': true
      }, className, !!className));

      return _react2.default.createElement(
        'div',
        null,
        disabled ? this.createDisabledElement(contentChildren, other) : _react2.default.createElement(
          _ReinforcedButton2.default,
          _extends({
            className: mergedClassName,
            containerElement: containerElement
          }, other, {
            onMouseLeave: this.handleMouseLeave,
            onMouseEnter: this.handleMouseEnter,
            onTouchStart: this.handleTouchStart,
            onTouchEnd: this.handleTouchEnd,
            onTouchTap: primaryTogglesNestedList ? this.handleNestedListToggle : onTouchTap,
            style: style
          }),
          _react2.default.createElement(
            'div',
            { style: mergedInnerDivStyle, className: 'zui-listItem-inner' },
            contentChildren
          )
        ),
        nestedList
      );
    }
  }]);

  return ListItem;
}(_react.Component);

ListItem.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  containerElement: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  disabled: _propTypes2.default.bool,
  initiallyOpen: _propTypes2.default.bool,
  innerDivStyle: _propTypes2.default.object,
  nestedItems: _propTypes2.default.arrayOf(_propTypes2.default.element),
  nestedLevel: _propTypes2.default.number,
  onMouseEnter: _propTypes2.default.func,
  onMouseLeave: _propTypes2.default.func,
  onNestedListToggle: _propTypes2.default.func,
  onTouchEnd: _propTypes2.default.func,
  onTouchStart: _propTypes2.default.func,
  onTouchTap: _propTypes2.default.func,
  open: _propTypes2.default.bool,
  /* This is the block element that contains the primary text.
    If a string is passed in, a div tag will be rendered.*/
  primaryText: _propTypes2.default.node,
  // If true, clicking or tapping the primary text of the ListItem toggles the nested list.
  primaryTogglesNestedList: _propTypes2.default.bool,
  style: _propTypes2.default.bool
};
ListItem.defaultProps = {
  containerElement: 'div',
  disabled: false,
  initiallyOpen: false,
  nestedItems: [],
  nestedLevel: 0,
  onMouseEnter: function onMouseEnter() {},
  onMouseLeave: function onMouseLeave() {},
  onNestedListToggle: function onNestedListToggle() {},
  onTouchEnd: function onTouchEnd() {},
  onTouchStart: function onTouchStart() {},
  open: null,
  primaryTogglesNestedList: true
};
exports.default = ListItem;