'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ClickAwayListener = require('../internal/ClickAwayListener');

var _ClickAwayListener2 = _interopRequireDefault(_ClickAwayListener);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _alertError = require('../svg-embedded/alertError');

var _alertError2 = _interopRequireDefault(_alertError);

var _clear = require('../svg-embedded/clear');

var _clear2 = _interopRequireDefault(_clear);

var _done = require('../svg-embedded/done');

var _done2 = _interopRequireDefault(_done);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Message = function (_Component) {
  _inherits(Message, _Component);

  function Message() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Message);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Message.__proto__ || Object.getPrototypeOf(Message)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      open: false,
      message: undefined
    }, _this.componentClickAway = function () {
      if (_this.timerTransitionId) {
        // If transitioning, don't close the snackbar.
        return;
      }

      if (_this.props.open !== null && _this.props.onRequestClose) {
        _this.props.onRequestClose('clickaway');
      } else {
        _this.setState({ open: false });
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Message, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.setState({
        open: this.props.open,
        message: this.props.message
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.state.open) {
        this.setAutoHideTimer();
        this.setTransitionTimer();
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (this.props.open && nextProps.open && nextProps.message !== this.props.message) {
        this.setState({
          open: false
        });

        clearTimeout(this.timerOneAtTheTimeId);
        this.timerOneAtTheTimeId = setTimeout(function () {
          _this2.setState({
            message: nextProps.message,
            open: true
          });
        }, 400);
      } else {
        var open = nextProps.open;

        this.setState({
          open: open !== null ? open : this.state.open,
          message: nextProps.message
        });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevState.open !== this.state.open) {
        if (this.state.open) {
          this.setAutoHideTimer();
          this.setTransitionTimer();
        } else {
          clearTimeout(this.timerAutoHideId);
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.timerAutoHideId);
      clearTimeout(this.timerTransitionId);
      clearTimeout(this.timerOneAtTheTimeId);
    }
  }, {
    key: 'setTransitionTimer',


    // Timer that controls delay before click-away events are captured (based on when animation completes)
    value: function setTransitionTimer() {
      var _this3 = this;

      this.timerTransitionId = setTimeout(function () {
        _this3.timerTransitionId = undefined;
      }, 400);
    }
    // Timer that controls delay before snackbar auto hides

  }, {
    key: 'setAutoHideTimer',
    value: function setAutoHideTimer() {
      var _this4 = this;

      var autoHideDuration = this.props.autoHideDuration;

      if (autoHideDuration > 0) {
        clearTimeout(this.timerAutoHideId);
        this.timerAutoHideId = setTimeout(function () {
          if (_this4.props.open !== null && _this4.props.onRequestClose) {
            _this4.props.onRequestClose('timeout');
          } else {
            _this4.setState({ open: false });
          }
        }, autoHideDuration);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          autoHideDuration = _props.autoHideDuration,
          messageProp = _props.message,
          onRequestClose = _props.onRequestClose,
          style = _props.style,
          type = _props.type;
      var _state = this.state,
          message = _state.message,
          open = _state.open;


      var mergedClass = (0, _classnames2.default)({
        'zui-message': true,
        'open': open
      });

      var typeClass = (0, _classnames2.default)(_defineProperty({}, 'zui-message-' + type, true));

      var svgIconElement = type === 'info' || type === 'warning' ? _react2.default.createElement(_alertError2.default, null) : type === 'success' ? _react2.default.createElement(_done2.default, null) : _react2.default.createElement(_clear2.default, null);

      svgIconElement = (0, _react.cloneElement)(svgIconElement, {
        className: 'zui-message-svgicon',
        style: {
          width: '20px',
          height: '20px'
        }
      });
      return _react2.default.createElement(
        _ClickAwayListener2.default,
        { onClickAway: open ? this.componentClickAway : null },
        _react2.default.createElement(
          'div',
          { className: mergedClass, style: style },
          _react2.default.createElement(
            'div',
            { className: typeClass },
            svgIconElement
          ),
          _react2.default.createElement(
            'div',
            { className: 'zui-message-content' },
            message
          )
        )
      );
    }
  }]);

  return Message;
}(_react.Component);

Message.propTypes = {
  autoHideDuration: _propTypes2.default.number,
  className: _propTypes2.default.string,
  message: _propTypes2.default.node.isRequired,
  onRequestClose: _propTypes2.default.func,
  open: _propTypes2.default.bool.isRequired,
  style: _propTypes2.default.object,
  type: _propTypes2.default.oneOf(['info', 'success', 'warning', 'error'])
};
Message.defaultProps = {
  autoHideDuration: 3000,
  type: 'info'
};
exports.default = Message;