'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classNames2 = require('classNames');

var _classNames3 = _interopRequireDefault(_classNames2);

var _radioButtonUnchecked = require('../svg-embedded/radio-button-unchecked');

var _radioButtonUnchecked2 = _interopRequireDefault(_radioButtonUnchecked);

var _radioButtonChecked = require('../svg-embedded/radio-button-checked');

var _radioButtonChecked2 = _interopRequireDefault(_radioButtonChecked);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioButton = function (_Component) {
  _inherits(RadioButton, _Component);

  function RadioButton() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, RadioButton);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = RadioButton.__proto__ || Object.getPrototypeOf(RadioButton)).call.apply(_ref, [this].concat(args))), _this), _this.handleOnChange = function (event) {
      if (_this.props.disabled) return;
      if (_this.props.onCheck && !_this.props.checked) {
        _this.props.onCheck(event, _this.props.value);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(RadioButton, [{
    key: 'render',
    value: function render() {
      var _classNames;

      var _props = this.props,
          label = _props.label,
          labelStyle = _props.labelStyle,
          labelPosition = _props.labelPosition,
          name = _props.name,
          className = _props.className,
          disabled = _props.disabled,
          style = _props.style,
          checked = _props.checked,
          value = _props.value;


      var mergedClass = (0, _classNames3.default)((_classNames = {
        'zui-radio': true
      }, _defineProperty(_classNames, className, !!className), _defineProperty(_classNames, 'disabled', disabled), _defineProperty(_classNames, 'is-checked', checked), _defineProperty(_classNames, 'position-left', labelPosition === 'left'), _classNames));

      var mergedCheckClass = (0, _classNames3.default)({
        'zui-radio-uncheck-icon': true,
        'is-checked': checked
      });

      var mergedUnCheckClass = (0, _classNames3.default)({
        'zui-radio-check-icon': true,
        'is-checked': checked
      });

      var content = labelPosition === 'left' ? [_react2.default.createElement(
        'label',
        { key: 'label', className: 'zui-radio-label', style: labelStyle },
        label
      ), _react2.default.createElement(
        'div',
        { key: 'radiobox', className: 'zui-radio-icon-wrap' },
        _react2.default.createElement(_radioButtonUnchecked2.default, { className: mergedCheckClass }),
        _react2.default.createElement(_radioButtonChecked2.default, { className: mergedUnCheckClass })
      )] : [_react2.default.createElement(
        'div',
        { key: 'radiobox', className: 'zui-radio-icon-wrap' },
        _react2.default.createElement(_radioButtonUnchecked2.default, { className: mergedCheckClass }),
        _react2.default.createElement(_radioButtonChecked2.default, { className: mergedUnCheckClass })
      ), _react2.default.createElement(
        'label',
        { key: 'label', className: 'zui-radio-label', style: labelStyle },
        label
      )];

      var inputProps = {
        type: 'radio',
        className: 'zui-toggle-radio',
        onChange: this.handleOnChange,
        value: value,
        name: name,
        checked: checked // this is the controlled property for type = radio
      };

      return _react2.default.createElement(
        'div',
        { className: mergedClass, style: style },
        _react2.default.createElement('input', inputProps),
        _react2.default.createElement(
          'div',
          { className: 'zui-radio-track-wrap' },
          content
        )
      );
    }
  }]);

  return RadioButton;
}(_react.Component);

RadioButton.propTypes = {
  checked: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  label: _propTypes2.default.string,
  labelPosition: _propTypes2.default.oneOf(['left', 'right']),
  labelStyle: _propTypes2.default.object,
  name: _propTypes2.default.string,
  onCheck: _propTypes2.default.func,
  style: _propTypes2.default.object,
  value: _propTypes2.default.any
};
RadioButton.defaultProps = {
  checked: false,
  disabled: false
};
exports.default = RadioButton;