'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TextField = require('../TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Dropdown = require('../Dropdown');

var _Dropdown2 = _interopRequireDefault(_Dropdown);

var _shallowEqual = require('recompose/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = function (_Component) {
  _inherits(Select, _Component);

  function Select() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Select.__proto__ || Object.getPrototypeOf(Select)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      value: '',
      dropDownWidth: 0
    }, _this.handleItemTouchTap = function (key) {
      return function (event) {
        if (_this.props.onChange) {
          _this.props.onChange(event, key);
        }
        // if not controlled
        if (_this.props.value === undefined) {
          _this.setState({
            value: key
          });
        }
      };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Select, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          value = _props.value,
          defaultValue = _props.defaultValue;

      var initValue = value || defaultValue;
      if (initValue) {
        this.state = {
          value: initValue
        };
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.anchorEl = _reactDom2.default.findDOMNode(this.anchorEl);
      if (this.anchorEl) {
        this.setState({ // eslint-disable-line react/no-did-mount-set-state
          dropDownWidth: this.anchorEl.offsetWidth
        });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (!this.isSameOption(this.props.options, nextProps.options)) {
        var value = void 0;
        nextProps.options.some(function (option) {
          if (option.key === _this2.state.value) {
            value = option.key;
            return true;
          }
        });
        if (value) {
          this.setState({
            value: value
          });
        }
      }
      // if controlled
      if (nextProps.value !== undefined && this.props.value !== nextProps.value) {
        this.setState({
          value: nextProps.value
        });
      }
    }
  }, {
    key: 'isSameOption',
    value: function isSameOption(opt, optNew) {
      if (opt.length !== optNew.length) {
        return false;
      }
      var isSame = true;
      opt.some(function (o, index) {
        if (!(0, _shallowEqual2.default)(o, optNew[index])) {
          isSame = false;
          return true;
        }
      });
      return isSame;
    }
  }, {
    key: 'findOptionValueByKey',
    value: function findOptionValueByKey(opt, key) {
      // init value = '' to suppress the warning uncontrolled change to controlled
      var optionValue = '';
      opt.some(function (o) {
        if (o.key === key) {
          optionValue = o.value;
          return true;
        }
      });
      return optionValue;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          options = _props2.options,
          hintText = _props2.hintText;


      var anchor = _react2.default.createElement(_TextField2.default, {
        style: { cursor: 'pointer' },
        readOnly: 'readonly',
        appendIcon: true,
        value: this.findOptionValueByKey(options, this.state.value),
        hintText: hintText
      });

      var dropdownMenuStyle = {
        width: this.state.dropDownWidth + 'px'
      };

      return _react2.default.createElement(
        _Dropdown2.default,
        {
          anchorEl: anchor,
          align: 'middle',
          trigger: 'click',
          ref: function ref(el) {
            return _this3.anchorEl = el;
          }
        },
        _react2.default.createElement(
          _Dropdown.DropdownMenu,
          {
            className: 'zui-select',
            style: dropdownMenuStyle
          },
          options.map(function (option) {
            var itemClassName = (0, _classnames2.default)({
              'zui-select-item': true,
              'is-selected': option.key === _this3.state.value
            });
            return _react2.default.createElement(
              _Dropdown.DropdownMenuItem,
              {
                className: itemClassName,
                key: option.key,
                onTouchTap: _this3.handleItemTouchTap(option.key)
              },
              option.value
            );
          })
        )
      );
    }
  }]);

  return Select;
}(_react.Component);

Select.propTypes = {
  children: _propTypes2.default.node,
  defaultValue: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  hintText: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  onRequestClose: _propTypes2.default.func,
  options: _propTypes2.default.array.isRequired,
  value: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string])
};
exports.default = Select;