'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _FloatingBar = require('./FloatingBar');

var _FloatingBar2 = _interopRequireDefault(_FloatingBar);

var _Tab = require('./Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tabs = function (_Component) {
  _inherits(Tabs, _Component);

  function Tabs() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Tabs);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Tabs.__proto__ || Object.getPrototypeOf(Tabs)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      selectedIndex: 0,
      tabWidthArray: []
    }, _this.handleTabTouchTap = function (tabValue, event, tab) {
      var value = _this.props.value;
      var index = tab.props.index;

      if (value && value !== tabValue || _this.state.selectedIndex !== index) {
        _this.props.onChange(tabValue || index, event, tab);
      }
      _this.setState({ selectedIndex: index });

      if (tab.props.onActive) {
        tab.props.onActive(tab);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Tabs, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var initialIndex = this.props.initialSelectedIndex;

      this.setState({
        selectedIndex: this.props.value !== undefined ? this.getSelectedIndex(this.props) : initialIndex < this.getTabCount() ? initialIndex : 0
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setTabWidthArray();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      if (newProps.value !== undefined) {
        this.setState({
          selectedIndex: this.getSelectedIndex(newProps)
        });
      }
    }
  }, {
    key: 'getSelectedIndex',
    value: function getSelectedIndex(props) {
      var selectedIndex = -1;

      this.getTabs().forEach(function (tab, index) {
        if (props.value === tab.props.value) {
          selectedIndex = index;
        }
      });

      return selectedIndex;
    }
  }, {
    key: 'getTabs',
    value: function getTabs() {
      var tabs = [];

      _react.Children.forEach(this.props.children, function (tab) {
        if ((0, _react.isValidElement)(tab)) {
          tabs.push(tab);
        }
      });

      return tabs;
    }
  }, {
    key: 'getTabCount',
    value: function getTabCount() {
      return this.getTabs().length;
    }
  }, {
    key: 'getSelected',
    value: function getSelected(tab, index) {
      var value = this.props.value;
      return value ? value === tab.props.value : this.state.selectedIndex === index;
    }
  }, {
    key: 'setTabWidthArray',
    value: function setTabWidthArray() {
      var tabWidthArray = [];
      var tabs = this.getTabs();
      var tabCount = tabs.length;
      for (var i = 0; i < tabCount; i++) {
        tabWidthArray[i] = _reactDom2.default.findDOMNode(this['tab' + i]).offsetWidth;
      }
      this.setState({
        tabWidthArray: tabWidthArray
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          value = _props.value;


      var selectedIndex = 0;
      var tabContent = [];
      var tabs = this.getTabs().map(function (tab, index) {
        process.env.NODE_ENV !== "production" ? (0, _warning2.default)(tab.type === _Tab2.default, 'Zui: Tabs only accepts Tab Components as children.\n        Found ' + (tab.type.muiName || tab.type) + ' as child number ' + (index + 1) + ' of Tabs') : void 0;

        process.env.NODE_ENV !== "production" ? (0, _warning2.default)(!value || tab.props.value !== undefined, 'Zui: Tabs value prop has been passed, but Tab ' + index + '\n        does not have a value prop. Needs value if Tabs is going\n        to be a controlled component.') : void 0;

        var selected = _this2.getSelected(tab, index);
        if (selected) {
          selectedIndex = index;
        }
        tabContent.push(tab.props.children ? (0, _react.createElement)('div', {
          key: index,
          className: 'zui-tab-content-item',
          selected: selected,
          style: { display: !_this2.getSelected(tab, index) ? 'none' : undefined }
        }, tab.props.children) : undefined);

        return (0, _react.cloneElement)(tab, {
          ref: function ref(el) {
            return _this2['tab' + index] = el;
          },
          key: index,
          index: index,
          selected: selected,
          onTouchTap: _this2.handleTabTouchTap
        });
      });

      var mergedClassNames = (0, _classnames2.default)(_defineProperty({
        'zui-tabs': true
      }, className, !!className));

      var tabWidthArray = this.state.tabWidthArray;
      var width = tabWidthArray[selectedIndex];
      var translateX = 0;
      tabWidthArray.forEach(function (tabWidth, index) {
        if (index < selectedIndex) {
          translateX += tabWidthArray[index];
        }
      });
      return _react2.default.createElement(
        'div',
        { className: mergedClassNames },
        _react2.default.createElement(
          'div',
          { className: 'zui-tabs-header' },
          _react2.default.createElement(_FloatingBar2.default, { width: width, translateX: translateX }),
          tabs
        ),
        _react2.default.createElement(
          'div',
          { className: 'zui-tabs-content' },
          tabContent
        )
      );
    }
  }]);

  return Tabs;
}(_react.Component);

Tabs.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  initialSelectedIndex: _propTypes2.default.number,
  onChange: _propTypes2.default.func,
  value: _propTypes2.default.any
};
Tabs.defaultProps = {
  initialSelectedIndex: 0,
  onChange: function onChange() {}
};
exports.default = Tabs;