'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _EnhancedTextarea = require('./EnhancedTextarea');

var _EnhancedTextarea2 = _interopRequireDefault(_EnhancedTextarea);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _shallowEqual = require('recompose/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _Popover = require('../Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var _arrowDropDown = require('../svg-embedded/arrow-drop-down');

var _arrowDropDown2 = _interopRequireDefault(_arrowDropDown);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function isValid(value) {
  return value !== '' && value !== undefined && value !== null && !(Array.isArray(value) && value.length === 0);
}

var TextField = function (_Component) {
  _inherits(TextField, _Component);

  function TextField() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TextField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TextField.__proto__ || Object.getPrototypeOf(TextField)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isFocused: false,
      errorText: undefined,
      hasValue: false
    }, _this.handleInputBlur = function (event) {
      _this.setState({ isFocused: false });
      if (_this.props.onBlur) {
        _this.props.onBlur(event);
      }
    }, _this.handleInputChange = function (event) {
      if (!_this.props.hasOwnProperty('value')) {
        _this.setState({ hasValue: isValid(event.target.value) });
      }
      if (_this.props.onChange) {
        _this.props.onChange(event, event.target.value);
      }
    }, _this.handleInputFocus = function (event) {
      if (_this.props.disabled) {
        return;
      }
      _this.setState({ isFocused: true });
      if (_this.props.onFocus) {
        _this.props.onFocus(event);
      }
    }, _this.handleHeightChange = function (event, height) {
      var newHeight = height + 24;
      if (_this.props.labelText) {
        newHeight += 24;
      }
      _reactDom2.default.findDOMNode(_this).style.height = newHeight + 'px';
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TextField, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          name = _props.name,
          hintText = _props.hintText,
          labelText = _props.labelText,
          id = _props.id;


      this.setState({
        errorText: this.props.errorText,
        hasValue: isValid(this.props.value) || isValid(this.props.defaultValue)
      });

      process.env.NODE_ENV !== "production" ? (0, _warning2.default)(name || hintText || labelText || id, 'ZUI: We don\'t have enough information\n      to build a robust unique id for the TextField component. Please provide an id or a name.') : void 0;

      var uniqueId = name + '-' + hintText + '-' + labelText + '-' + Math.floor(Math.random() * 0xFFFF);
      this.uniqueId = uniqueId.replace(/[^A-Za-z0-9-]/gi, '');
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.errorText !== this.props.errorText) {
        this.setState({
          errorText: nextProps.errorText
        });
      }

      if (nextProps.hasOwnProperty('value')) {
        var hasValue = isValid(nextProps.value);

        this.setState({
          hasValue: hasValue
        });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(0, _shallowEqual2.default)(this.props, nextProps) || !(0, _shallowEqual2.default)(this.state, nextState);
    }
  }, {
    key: 'getInputNode',
    value: function getInputNode() {
      return this.props.multiLine ? this.input.getInputNode() : _reactDom2.default.findDOMNode(this.input);
    }
  }, {
    key: 'blur',
    value: function blur() {
      if (this.input) {
        this.getInputNode().blur();
      }
    }
  }, {
    key: 'focus',
    value: function focus() {
      if (this.input) {
        this.getInputNode().focus();
      }
    }
  }, {
    key: 'select',
    value: function select() {
      if (this.input) {
        this.getInputNode().select();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _classNames,
          _this2 = this;

      var _props2 = this.props,
          appendIcon = _props2.appendIcon,
          children = _props2.children,
          labelText = _props2.labelText,
          id = _props2.id,
          errorText = _props2.errorText,
          errorStyle = _props2.errorStyle,
          className = _props2.className,
          type = _props2.type,
          style = _props2.style,
          hintText = _props2.hintText,
          rows = _props2.rows,
          rowsMax = _props2.rowsMax,
          disabled = _props2.disabled,
          defaultValue = _props2.defaultValue,
          multiLine = _props2.multiLine,
          value = _props2.value,
          other = _objectWithoutProperties(_props2, ['appendIcon', 'children', 'labelText', 'id', 'errorText', 'errorStyle', 'className', 'type', 'style', 'hintText', 'rows', 'rowsMax', 'disabled', 'defaultValue', 'multiLine', 'value']);

      var inputId = id || this.uniqueId;

      var mergedWrapClassName = (0, _classnames2.default)((_classNames = {
        'zui-textfield-wrap': true
      }, _defineProperty(_classNames, className, !!className), _defineProperty(_classNames, 'is-focused', this.state.hasValue || this.state.isFocused), _defineProperty(_classNames, 'hint-show', !this.state.hasValue && !labelText || !this.state.hasValue && !!labelText && this.state.isFocused), _defineProperty(_classNames, 'disabled', disabled), _classNames));

      var wrapStyle = _extends({}, style, {
        height: (rows - 1) * 24 + (labelText ? 72 : 48) + 'px'
      });

      var errorTextStyle = _extends({}, errorStyle, {
        bottom: labelText && errorText ? multiLine ? '3px' : '15px' : 2 + 'px'
      });

      var inputProps = {
        id: inputId,
        ref: function ref(elem) {
          return _this2.input = elem;
        },
        disabled: disabled,
        onBlur: this.handleInputBlur,
        onChange: this.handleInputChange,
        onFocus: this.handleInputFocus
      };

      var inputStyle = _extends({}, {
        marginTop: labelText && !multiLine ? '14px' : '0'
      });

      var inputElement = multiLine ? _react2.default.createElement(_EnhancedTextarea2.default, _extends({
        rows: rows,
        rowsMax: rowsMax,
        hintText: hintText,
        labelText: labelText
      }, inputProps, {
        onHeightChange: this.handleHeightChange
      })) : _react2.default.createElement('input', _extends({
        style: inputStyle,
        type: type,
        className: 'zui-textfield-input'
      }, other, inputProps, {
        value: value,
        defaultValue: defaultValue
      }));
      /**
       *select component will need this
       */
      var popover = _react2.default.Children.map(children, function (child) {
        if (child.type === _Popover2.default) {
          return child;
        }
      });
      var appendIconClassName = (0, _classnames2.default)({
        'zui-select-arraw': true,
        'is-drop': !!this.state.isFocused
      });
      return _react2.default.createElement(
        'div',
        { style: wrapStyle, className: mergedWrapClassName },
        _react2.default.createElement(
          'label',
          { htmlFor: inputId, className: 'zui-textfield-label' },
          labelText
        ),
        _react2.default.createElement(
          'div',
          { className: 'zui-textfield-hint' },
          hintText
        ),
        inputElement,
        _react2.default.createElement('hr', { className: 'zui-textfield-underline' }),
        _react2.default.createElement('hr', { className: 'zui-textfield-underline-overlap' }),
        _react2.default.createElement(
          'div',
          { className: 'zui-textfield-errortext', style: errorTextStyle },
          errorText
        ),
        popover,
        appendIcon && _react2.default.createElement(_arrowDropDown2.default, { className: appendIconClassName })
      );
    }
  }]);

  return TextField;
}(_react.Component);

TextField.propTypes = {
  appendIcon: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  defaultValue: _propTypes2.default.any,
  disabled: _propTypes2.default.bool,
  errorStyle: _propTypes2.default.object,
  errorText: _propTypes2.default.node,
  hintText: _propTypes2.default.node,
  id: _propTypes2.default.string,
  labelText: _propTypes2.default.node,
  multiLine: _propTypes2.default.bool,
  name: _propTypes2.default.string,
  onBlur: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  rows: _propTypes2.default.number,
  rowsMax: _propTypes2.default.number,
  style: _propTypes2.default.object,
  type: _propTypes2.default.string,
  value: _propTypes2.default.any
};
TextField.defaultProps = {
  disabled: false,
  multiLine: false,
  type: 'text',
  rows: 1
};
exports.default = TextField;