'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classNames2 = require('classNames');

var _classNames3 = _interopRequireDefault(_classNames2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Toggle = function (_Component) {
  _inherits(Toggle, _Component);

  function Toggle() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Toggle);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Toggle.__proto__ || Object.getPrototypeOf(Toggle)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      switched: false
    }, _this.handleTouchTap = function (event) {
      if (_this.props.disabled) return;
      var switched = _this.state.switched;

      if (_this.props.toggled === undefined) {
        _this.setState({
          switched: !switched
        });
      }
      if (_this.props.onToggle) {
        _this.props.onToggle(event, !switched);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Toggle, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          toggled = _props.toggled,
          defaultToggled = _props.defaultToggled;


      if (toggled || defaultToggled) {
        this.setState({ switched: true });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.disabled) return;
      if (nextProps.toggled !== undefined && nextProps.toggled !== this.toggled) {
        this.setState({
          switched: nextProps.toggled
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _classNames;

      var _props2 = this.props,
          defaultToggled = _props2.defaultToggled,
          label = _props2.label,
          labelStyle = _props2.labelStyle,
          labelPosition = _props2.labelPosition,
          className = _props2.className,
          disabled = _props2.disabled,
          style = _props2.style,
          toggled = _props2.toggled;


      var mergedClass = (0, _classNames3.default)((_classNames = {
        'zui-toggle': true
      }, _defineProperty(_classNames, className, !!className), _defineProperty(_classNames, 'disabled', disabled), _defineProperty(_classNames, 'is-switched', this.state.switched), _defineProperty(_classNames, 'position-right', labelPosition === 'right'), _classNames));

      var content = labelPosition === 'left' ? [_react2.default.createElement(
        'label',
        { key: 'label', className: 'zui-toggle-label', style: labelStyle },
        label
      ), _react2.default.createElement(
        'div',
        { key: 'track', className: 'zui-toggle-wrap' },
        _react2.default.createElement('div', { className: 'zui-toggle-track' }),
        _react2.default.createElement('div', { className: 'zui-toggle-thumb' })
      )] : [_react2.default.createElement(
        'div',
        { key: 'track', className: 'zui-toggle-wrap' },
        _react2.default.createElement('div', { className: 'zui-toggle-track' }),
        _react2.default.createElement('div', { className: 'zui-toggle-thumb' })
      ), _react2.default.createElement(
        'label',
        { key: 'label', className: 'zui-toggle-label', style: labelStyle },
        label
      )];
      var inputProps = {
        type: 'checkbox',
        className: 'zui-toggle-checkbox',
        onTouchTap: this.handleTouchTap
      };
      if (this.props.hasOwnProperty('defaultToggled')) {
        inputProps.defaultChecked = defaultToggled;
      } else if (this.props.hasOwnProperty('toggled')) {
        inputProps.checked = toggled;
      }
      return _react2.default.createElement(
        'div',
        { className: mergedClass, style: style },
        _react2.default.createElement('input', inputProps),
        _react2.default.createElement(
          'div',
          { className: 'zui-toggle-track-wrap' },
          content
        )
      );
    }
  }]);

  return Toggle;
}(_react.Component);

Toggle.propTypes = {
  className: _propTypes2.default.string,
  /**
   * Determines whether the Toggle is initially turned on.
   * Warning: This cannot be used in conjunction with toggled.
   * Decide between using a controlled or uncontrolled input element and
   * remove one of these props
   */
  defaultToggled: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  label: _propTypes2.default.node,
  labelPosition: _propTypes2.default.oneOf(['left', 'right']),
  labelStyle: _propTypes2.default.object,
  onToggle: _propTypes2.default.func,
  style: _propTypes2.default.object,
  toggled: _propTypes2.default.bool
};
Toggle.defaultProps = {
  defaultToggled: false,
  disabled: false,
  labelPosition: 'left'
};
exports.default = Toggle;